package com.inteligr8.alfresco.activiti;

import java.util.Arrays;
import java.util.UUID;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.condition.EnabledIf;

import com.inteligr8.alfresco.activiti.model.AppVersion;
import com.inteligr8.alfresco.activiti.model.CreateProcessInstance;
import com.inteligr8.alfresco.activiti.model.ProcessInstance;
import com.inteligr8.alfresco.activiti.model.User;
import com.inteligr8.alfresco.activiti.model.Variable;

public abstract class ConnectionClientIT extends ConditionalIT {
	
	public abstract ApsPublicRestApi getClient();
	
	@Test
	@EnabledIf("hostExists")
	public void testAppVersion() {
		AppVersion obj = this.getClient().getAppVersionApi().get();
		
		Assertions.assertNotNull(obj);
		Assertions.assertEquals("1", obj.getMajorVersion());
		Assertions.assertEquals("bpmSuite", obj.getType());
	}
	
	@Test
	@EnabledIf("hostExists")
	public void testProfile() {
		User obj = this.getClient().getProfileApi().get();
		
		Assertions.assertNotNull(obj);
		Assertions.assertEquals("admin@app.activiti.com", obj.getEmail());
	}
	
	@Test
	@EnabledIf("hostExists")
	public void testStartProcess() {
		CreateProcessInstance request = new CreateProcessInstance();
		request.setProcessDefinitionKey("qcDocument");
		request.setVariables(Arrays.asList(new Variable("acsNodeId", null, null, UUID.randomUUID().toString())));
		
		ProcessInstance response = this.getClient().getProcessInstancesApi().create(request);
		
		Assertions.assertNotNull(response);
		Assertions.assertNotNull(response.getId());
		Assertions.assertNotNull(response.getId().length() > 0);
		Assertions.assertEquals("qcDocument", response.getProcessDefinitionKey());
	}

}
